(function ($) {
    mui.init();
    var pageSize = 5, pageNo = 1, canPull = true;
    var param = {
        'pager.pageSize': pageSize,
        'pager.pageNo': pageNo,
        'parameters[currencyType]':1
    };
    var page = {
        init: function () {
            base.setPageRem();
            page.queryList();
            page.bind();
        },
        queryList: function () {
            var querySettings = {
                url: Constants.bzDetail,
                data: param,
                type: 'post'
            };

            muiAjax(querySettings, function (data) {
                var rows = data.rows;
                var rentlength = rows.length, totalLength = data.totalRows;
                if (rows.length > 0) {
                    if (rentlength < pageSize) {
                        canPull = false;
                    } else if (totalLength == (pageSize * (pageNo - 1) + rentlength)) {
                        canPull = false
                    } else {
                        canPull = true;
                    }

                    var obj = {
                        rows: rows
                    };

                    var tmpl = mui('#rows-li-template')[0].innerHTML;
                    mui('#listData')[0].innerHTML += Mustache.render(tmpl, obj);

                } else {
                    canPull = false;
                }
            }, function (status) {

            });
        },
        bind: function () {
            var muiBack = mui('.mui-back')[0];
            mui('.mui-content').pullToRefresh({
                //上拉加载更多
                up: {
                    callback: function () {
                        var self = this;
                        setTimeout(function () {
                            if (canPull) {
                                pageNo += 1;
                                param['pager.pageNo'] = pageNo;
                                page.queryList();
                            }
                            self.endPullUpToRefresh(!canPull);
                        }, 500);
                    }
                }
            });            
        }
    };

mui.plusReady(page.init);
//  page.init();
})(mui);